(* Variants of the firewall protocol *)

#safenames off;;

(nu Server)( 
  Server[ !in_ Server
	| !out_Server
	| rec X.open o.(X | (nu n)data[in read.open_data.<n>])
	]
| rec X.(x)(X 
	   | password[in x.open_password.
			   (<in Server>|finished[open_finished.<out Server>])
	   ])
| !pause 30.open u
)
;;

#add a[rec X.
	 ( u[out a.open_u.<a>]
	 | out_a.in_a.open password.(path)path.(
	     o[out a.open_o]
	   | out_a.(
	       read[out a.in_read.open data.(m)in a.open_read.open finished.(path)path.print m.X]
	     | out_a.in_a.open read
	    )))]
;;

#add <a>|a[in_a.open ssapword.(path)path.(
	    o[out a.open_o]
	  | out_a.(
	      read[out a.in_read.open data.(m)in a.open_read.open finished.(path)path.print m]
	    | out_a.in_a.open read
	    )
	  ) 
	 ]
;;

#debug;;
#tree;;
#stats;;


(* ----------------------------------------- *)

#safenames off;;

(nu server,data)( 
   server[rec X.(out_server.in_server.out_server.X |
		   password[out server.in login.open_password.
			      (<in server>|finished[open_finished.<out server>])
			   ]
		)
	 | data[rec X.in login.(c[out data.open_c.<toto>]|out_data.out login.X)]
	 ]
 )
;;

#add login[in_login.open password.(i)i.in_login.open c.(d)print d.out_login.open finished.(o)o]
;;

#add login[in_login.open sappword.(i)i.in_login.open c.(d)print d.out_login.open finished.(o)o]
;;


#debug;;
#tree;;
#stats;;
